about summary refs log tree commit diff
path: root/third_party/git/t/t2101-update-index-reupdate.sh
diff options
context:
space:
mode:
authorVincent Ambo <Vincent Ambo>2020-01-11T23·36+0000
committerVincent Ambo <Vincent Ambo>2020-01-11T23·40+0000
commit7ef0d62730840ded097b524104cc0a0904591a63 (patch)
treea670f96103667aeca4789a95d94ca0dff550c4ce /third_party/git/t/t2101-update-index-reupdate.sh
parent6a2a3007077818e24a3d56fc492ada9206a10cf0 (diff)
parent1b593e1ea4d2af0f6444d9a7788d5d99abd6fde5 (diff)
merge(third_party/git): Merge squashed git subtree at v2.23.0 r/373
Merge commit '1b593e1ea4d2af0f6444d9a7788d5d99abd6fde5' as 'third_party/git'
Diffstat (limited to 'third_party/git/t/t2101-update-index-reupdate.sh')
-rwxr-xr-xthird_party/git/t/t2101-update-index-reupdate.sh91
1 files changed, 91 insertions, 0 deletions
diff --git a/third_party/git/t/t2101-update-index-reupdate.sh b/third_party/git/t/t2101-update-index-reupdate.sh
new file mode 100755
index 000000000000..6c32d42c8c68
--- /dev/null
+++ b/third_party/git/t/t2101-update-index-reupdate.sh
@@ -0,0 +1,91 @@
+#!/bin/sh
+#
+# Copyright (c) 2006 Junio C Hamano
+#
+
+test_description='git update-index --again test.
+'
+
+. ./test-lib.sh
+
+test_expect_success 'update-index --add' '
+	echo hello world >file1 &&
+	echo goodbye people >file2 &&
+	git update-index --add file1 file2 &&
+	git ls-files -s >current &&
+	cat >expected <<-EOF &&
+	100644 $(git hash-object file1) 0	file1
+	100644 $(git hash-object file2) 0	file2
+	EOF
+	cmp current expected
+'
+
+test_expect_success 'update-index --again' '
+	rm -f file1 &&
+	echo hello everybody >file2 &&
+	if git update-index --again
+	then
+		echo should have refused to remove file1
+		exit 1
+	else
+		echo happy - failed as expected
+	fi &&
+	git ls-files -s >current &&
+	cmp current expected
+'
+
+test_expect_success 'update-index --remove --again' '
+	git update-index --remove --again &&
+	git ls-files -s >current &&
+	cat >expected <<-EOF &&
+	100644 $(git hash-object file2) 0	file2
+	EOF
+	cmp current expected
+'
+
+test_expect_success 'first commit' 'git commit -m initial'
+
+test_expect_success 'update-index again' '
+	mkdir -p dir1 &&
+	echo hello world >dir1/file3 &&
+	echo goodbye people >file2 &&
+	git update-index --add file2 dir1/file3 &&
+	echo hello everybody >file2 &&
+	echo happy >dir1/file3 &&
+	git update-index --again &&
+	git ls-files -s >current &&
+	cat >expected <<-EOF &&
+	100644 $(git hash-object dir1/file3) 0	dir1/file3
+	100644 $(git hash-object file2) 0	file2
+	EOF
+	cmp current expected
+'
+
+file2=$(git hash-object file2)
+test_expect_success 'update-index --update from subdir' '
+	echo not so happy >file2 &&
+	(cd dir1 &&
+	cat ../file2 >file3 &&
+	git update-index --again
+	) &&
+	git ls-files -s >current &&
+	cat >expected <<-EOF &&
+	100644 $(git hash-object dir1/file3) 0	dir1/file3
+	100644 $file2 0	file2
+	EOF
+	test_cmp expected current
+'
+
+test_expect_success 'update-index --update with pathspec' '
+	echo very happy >file2 &&
+	cat file2 >dir1/file3 &&
+	git update-index --again dir1/ &&
+	git ls-files -s >current &&
+	cat >expected <<-EOF &&
+	100644 $(git hash-object dir1/file3) 0	dir1/file3
+	100644 $file2 0	file2
+	EOF
+	cmp current expected
+'
+
+test_done